using FunWithDBs;

namespace DBDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void PrintPets(IEnumerable<Pet> pets)
        {
            foreach(var pet in pets)
            {
                var id = new Label { Text = pet.Id.ToString() };
                var name = new Label { Text = pet.Name.ToString() };
                var age = new Label { Text = pet.Age.ToString() };

                flowLayoutPanel1.Controls.AddRange(new Label[] { id, name, age });
            }
        }

        private async void button1_Click(object sender, EventArgs e)
        {
            var sqlDemo = new SqlDemo();
            await sqlDemo.AddPet();

            PrintPets(await sqlDemo.GetAllDogs());
        }

        private async void button2_Click(object sender, EventArgs e)
        {
            var dapperDemo = new DapperDemo();
            await dapperDemo.AddPetSimpleCrud();

            PrintPets(await dapperDemo.GetAllDogsSimpleCrud());
        }

        private async void button3_Click(object sender, EventArgs e)
        {
            var efDemo = new EFDemo();
            await efDemo.AddPet();

            PrintPets(await efDemo.GetAllDogs());
        }
    }
}