﻿using Dapper;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FunWithDBs
{
    public class DapperDemo
    {
        private string connectionString = @"server=(localdb)\MSSQLLocalDB;
                    Initial Catalog=PetsDB; Integrated Security=true";

        public async Task<List<Pet>> GetAllDogs()
        {
            using (var db = new SqlConnection(connectionString))
            {
                return (await db.QueryAsync<Pet>("WAITFOR DELAY '00:00:05';" +
                                     "SELECT * FROM Pets WHERE Type=@type", new { Type = "dog" })).ToList();
            }
        }

        public async Task AddPet()
        {
            using var db = new SqlConnection(connectionString);
            await db.ExecuteAsync("INSERT INTO Pets(Name, Type, Age) " +
                "VALUES (@name, @type, @age)", new Pet() { Name = "Ivo", Type = "bunny", Age = 23 });
        }

        public async Task<List<Pet>> GetAllDogsSimpleCrud()
        {
            using var db = new SqlConnection(connectionString);
            return (await db.GetListAsync<Pet>(new { Type = "dog" })).ToList();
        }

        public async Task AddPetSimpleCrud()
        {
            using var db = new SqlConnection(connectionString);
            await db.InsertAsync(new Pet() { Name = "Tomas", Type = "turtle", Age=23 });
        }
    }
}
