﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FunWithDBs
{
    public class PetDbContext : DbContext 
    {
        private string connectionString = @"server=(localdb)\MSSQLLocalDB;
                    Initial Catalog=PetsDB; Integrated Security=true";

        public DbSet<Pet> Pets { get; set; }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseSqlServer(connectionString);
        }
    }

    public class EFDemo
    {
        public async Task<List<Pet>> GetAllDogs()
        {
            using var db = new PetDbContext();
            return await db.Pets.Where(p => p.Type == "dog").ToListAsync();
        }

        public async Task AddPet()
        {
            using var db = new PetDbContext();
            db.Pets.Add(new Pet { Name = "Pelikan", Type = "pelican" });
            await db.SaveChangesAsync();
        }
    }
}
